  PROGRAM

WS_CHILD            EQUATE(40000000h)
WS_VISIBLE          EQUATE(10000000h)
WS_EX_CLIENTEDGE    EQUATE(200h)

SCI_START           EQUATE(2000)
SCI_ADDTEXT         EQUATE(SCI_START + 1)
SCI_SETSELBACK      EQUATE(SCI_START + 68)

SCN_CHARADDED       EQUATE(2001)

WM_NOTIFY            EQUATE(004Eh)

NMHDR GROUP,TYPE
hwndFrom UNSIGNED       !Window handle to the control sending a message.
idFrom   UNSIGNED       !Identifier of the control sending a message
Code     UNSIGNED       !Notification code. This member can be a control-specific
                        ! notification code or it can be one of the common notification codes
      END

SCNotification GROUP,TYPE
NotifyHeader LIKE(NMHDR)
Position        LONG
    ! SCN_STYLENEEDED, SCN_MODIFIED, SCN_DWELLSTART,
    ! SCN_DWELLEND, SCN_CALLTIPCLICK,
    ! SCN_HOTSPOTCLICK, SCN_HOTSPOTDOUBLECLICK
ch              LONG             ! SCN_CHARADDED, SCN_KEY
modifiers       LONG      ! SCN_KEY, SCN_HOTSPOTCLICK, SCN_HOTSPOTDOUBLECLICK
modificationType LONG ! SCN_MODIFIED
pszText          LONG   ! SCN_MODIFIED
length           LONG         ! SCN_MODIFIED
linesAdded       LONG     ! SCN_MODIFIED
message          LONG     ! SCN_MACRORECORD
wParam           LONG      ! SCN_MACRORECORD
lParam           LONG      ! SCN_MACRORECORD
line             LONG          ! SCN_MODIFIED
foldLevelNow     LONG   ! SCN_MODIFIED
foldLevelPrev    LONG  ! SCN_MODIFIED
margin           LONG     ! SCN_MARGINCLICK
listType         LONG       ! SCN_USERLISTSELECTION
x                LONG       ! SCN_DWELLSTART, SCN_DWELLEND
y                LONG              ! SCN_DWELLSTART, SCN_DWELLEND
             END


POINT GROUP,TYPE
x   LONG
y   LONG
      END

RECT    GROUP,TYPE
left     SIGNED
top      SIGNED
right    SIGNED
bottom   SIGNED
        END

  MAP
    MODULE('win32API')

     CallWindowProc(UNSIGNED wndprc, |
                    UNSIGNED hWnd,   |
                    UNSIGNED uMsg,   |
                    LONG wParam, |
                    LONG lParam      |
                   ),LONG,PASCAL,NAME('CallWindowProcA')

      InitCommonControls(),PASCAL

      CreateWindowEx(UNSIGNED dwExStyle,     |
                    *CSTRING lpClassName,    |
                    <*CSTRING lpWindowName>, |
                    UNSIGNED dwStyle,        |
                    SIGNED x,                |
                    SIGNED y,                |
                    SIGNED nWidth,           |
                    SIGNED nHeight,          |
                    UNSIGNED hWndParent,     |
                    UNSIGNED hMenu,          |
                    UNSIGNED hInstance,      |
                    LONG lpParam             |
                   ),LONG,PASCAL,RAW,NAME('CreateWindowExA')

      DestroyWindow(UNSIGNED hWnd),BOOL,PASCAL,PROC


      GetClientRect(UNSIGNED hWnd, |
                    *RECT pRect    |
                   ),PASCAL,RAW

      GetWindowRect(UNSIGNED hWnd,    | handle to window
                  *RECT lpRect        | window coordinates
                  ),BOOL,PASCAL,RAW,PROC

      MapWindowPoints(UNSIGNED hWndFrom,     | handle to source window
                      UNSIGNED hWndTo,       | handle to destination window
                      *? lpPoints,           | array of points to map
                      UNSIGNED cPoints       | number of points in array
                     ),LONG,RAW,PASCAL,PROC

      MoveWindow(UNSIGNED hWnd,     |
                 SIGNED X,      |
                 SIGNED Y,      |
                 SIGNED nWidth, |
                 SIGNED nHeight,|
                 BOOL bRepaint  |
                ),BOOL,PASCAL,PROC

     SetWindowPos(UNSIGNED hWnd,            |
                  UNSIGNED hWndInsertAfter, |
                  SIGNED X,                 |
                  SIGNED Y,                 |
                  SIGNED cx,                |
                  SIGNED cy,                |
                  UNSIGNED uFlags           |
                ),BOOL,PASCAL,PROC

      SendMessage(UNSIGNED hWnd,     |
                  UNSIGNED uMsg,      |
                  UNSIGNED wParam,   |
                  LONG lParam        |
                 ),LONG,PASCAL,PROC,NAME('SendMessageA')

      SciSendText(UNSIGNED hWnd,        |
                  UNSIGNED uMsg,        |
                  UNSIGNED wParam,      |
                  *CSTRING szText       |
                 ),LONG,PASCAL,RAW,PROC,NAME('SendMessageA')

      LoadLibrary(*CSTRING pszModuleFileName), UNSIGNED, PASCAL, RAW, NAME('LoadLibraryA')
      FreeLibrary(UNSIGNED hModule), LONG, PASCAL, PROC
      MoveMemory(*? Dest, UNSIGNED Src, UNSIGNED cbLength),PASCAL,RAW,NAME('RtlMoveMemory')
      GetLastError(),ULONG,PASCAL
    END

SciScWndProc  PROCEDURE(UNSIGNED hWnd,   |
                        UNSIGNED uMsg,   |
                        LONG wParam, |
                        LONG lParam  |
                       ),LONG,PASCAL



  END

W WINDOW('Scintilla Editor test'),AT(,,319,216),SYSTEM,GRAY,RESIZE,IMM
     END


OrigWndProc     UNSIGNED,AUTO
rcWin           LIKE(RECT),AUTO
ClienthWnd      UNSIGNED,AUTO
ScihWnd         UNSIGNED,AUTO
hInstance       UNSIGNED,AUTO
szClassName     CSTRING('Scintilla')
szWindowName    CSTRING('Test')
szModuleName    CSTRING('SciLexer.DLL')
hModSciEdit     UNSIGNED,AUTO

szTextBuffer    CSTRING(16384),AUTO
nChars          LONG,AUTO

bControlInitialized     BOOL
  CODE

  OPEN(W)


  !--------------------------------------------------------------
  ! Load the control library.  Note: it registers itself
  ! You should perform additional error checking in case this fails
  !--------------------------------------------------------------
  hModSciEdit = LoadLibrary(szModuleName)
  IF hModSciEdit <> 0
    bControlInitialized = True
  ELSE
    bControlInitialized = False
  END
  IF bControlInitialized
    OrigWndProc = W{PROP:ClientWndProc}
    W{PROP:ClientWndProc} = ADDRESS(SciScWndProc)
    ClienthWnd = W{PROP:ClientHandle}
    GetClientRect(ClienthWnd, rcWin)
    hInstance = SYSTEM{PROP:AppInstance}

    ScihWnd = CreateWindowEx(WS_EX_CLIENTEDGE,        |
                             szClassName,             |
                             ,            |
                             WS_CHILD + WS_VISIBLE,   |
                             rcWin.left,              |
                             rcWin.top,               |
                             rcWin.left + rcWin.Right,|
                             rcWin.top + rcWin.Bottom,|
                             ClienthWnd,              |
                             1001,                    |Id to use in notification messages
                             hInstance,               |
                             0)
  END

  nChars = 0

  ACCEPT
    CASE EVENT()
    OF EVENT:OpenWindow
      IF bControlInitialized
        !--------------------------------------------------------------
        ! Set the selected text background color
        !--------------------------------------------------------------
        SendMessage(ScihWnd, SCI_SETSELBACK, 1, Color:Lime) ! ;-)

        !--------------------------------------------------------------
        ! Send the message to add text to the control
        !--------------------------------------------------------------
        szTextBuffer = 'This is the text to add to the edit control.<13,10>This is on a new line.'
        SciSendText(ScihWnd, SCI_ADDTEXT, LEN(szTextBuffer), szTextBuffer)
      END

    OF EVENT:Sized
      IF bControlInitialized
        GetClientRect(ClienthWnd, rcWin)
        SetWindowPos(ScihWnd, 0,               |
                     rcWin.left, rcWin.top,    |
                     rcWin.right - rcWin.left, |
                     rcWin.bottom - rcWin.top, 0)
      END

    OF SCN_CHARADDED !(posted from the subclassed window procedure)
     !--------------------------------------------------------------
     ! Do what ever you want when the user types a regular character
     ! this example just changes the window's caption
     !--------------------------------------------------------------
     nChars +=1
     W{PROP:Text} = 'Character Added '& nChars

    END
  END

  CLOSE(W)

  IF hModSciEdit <> 0
    FreeLibrary(hModSciEdit)
  END
  RETURN


!===================================================================
! The window procedure callback, Don't forget the PASCAL attribute
!===================================================================
SciScWndProc  PROCEDURE(UNSIGNED hWnd, |
                        UNSIGNED uMsg, |
                        LONG wParam,   |
                        LONG lParam    |
                       )!,LONG,PASCAL
NM     LIKE(NMHDR),AUTO
  CODE
  CASE uMsg
  OF WM_NOTIFY
    MoveMemory(NM, lParam, SIZE(NM))

    !--------------------------------------------------------------
    ! When the Scintilla edit control was created, I gave it an id
    ! of 1001. This and the hWnd of the control can be used for
    ! identification of the notification message.
    !--------------------------------------------------------------
    IF NM.hwndFrom = ScihWnd AND NM.idFrom = 1001
      CASE NM.Code
      OF SCN_CHARADDED
        !--------------------------------------------------------------
        ! Post this message to Clarion's accept loop.
        ! SCN_CHARADDED is the same as EVENT:User + 977 so it can be
        ! used with POST()
        !--------------------------------------------------------------
        POST(SCN_CHARADDED)
      END
    END
  END

  RETURN CallWindowProc(OrigWndProc, hWnd, uMsg, wParam, lParam )
